package ExtraCommandsOverridesPackage
{
	function GameConnection::onDeath(%client, %source, %killer, %type, %location)
	{
		if(%client.isControlling)
		{
			%client.controlling.setControlObject(%client.controlling.player);
			
			messageClient(%client.controlling, '', "\c6Your controller died!");
			
			%client.controlling.isControlled = 0;
			%client.isControlling = 0;
			
			%client.controlling.controller = "";
			%client.controlling = "";
		}
		else if(%client.isControlled)
		{
			%client.controller.setControlObject(%client.controller.player);
			
			messageClient(%client.controller, '', "\c6Your controllee died!");
			
			%client.controller.isControlling = 0;
			%client.isControlled = 0;
			
			%client.controller.controlling = "";
			%client.controller = "";
		}
		
		Parent::onDeath(%client, %source, %killer, %type, %location);
	}

	function GameConnection::onDrop(%this)
	{
		if(%this.isControlling)
		{
			%this.controlling.setControlObject(%this.controlling.player);
			
			messageClient(%this.controlling, '', "\c6Your controller disconnected!");
			
			%this.controlling.isControlled = 0;
			%this.isControlling = 0;
			
			%this.controlling.controller = "";
			%this.controlling = "";
		}
		else if(%this.isControlled)
		{
			%this.controller.setControlObject(%this.controller.player);
			
			messageClient(%this.controller, '', "\c6Your controllee disconnected!");
			
			%this.controller.isControlling = 0;
			%this.isControlled = 0;
			
			%this.controller.controlling = "";
			%this.controller = "";
		}
		Parent::onDrop(%this);
	}
	
	function serverCmdUseSprayCan(%this, %id)
	{
		if(%this.player.isFrozen || %this.isControlled || %this.player.isJailed)
			return;
		
		Parent::serverCmdUseSprayCan(%this, %id);
	}

	function serverCmdUseFxCan(%this, %id)
	{
		if(%this.player.isFrozen || %this.isControlled || %this.player.isJailed)
			return;
		
		Parent::serverCmdUseFxCan(%this, %id);
	}
	
	function serverCmdPlantBrick(%this)
	{
		if(%this.player.isFrozen || %this.isControlled || %this.player.isJailed)
		{
			serverCmdCancelBrick(%this);
			return;
		}
		Parent::serverCmdPlantBrick(%this);
	}

	function GameConnection::instantRespawn(%this)
	{
		if(%this.player.isFrozen || %this.isControlled || %this.player.isJailed)
			return;

		Parent::instantRespawn(%this);
	}
	
	function serverCmdSuicide(%this)
	{
		if(%this.player.isFrozen || %this.isControlled || %this.player.isJailed)
			return;
		
		Parent::serverCmdSuicide(%this);
	}	
	
	function GameConnection::CreatePlayer(%this, %spawnPoint)
	{
		if(%this.isControlling)
		{
			%this.controlling.setControlObject(%this.controlling.player);
			
			messageClient(%this.controlling, '', "\c6Your controller respawned!");
			
			%this.controlling.isControlled = 0;
			%this.isControlling = 0;
			
			%this.controlling.controller = "";
			%this.controlling = "";
		}
		else if(%this.isControlled)
		{
			%this.controller.setControlObject(%this.controller.player);
			
			messageClient(%this.controller, '', "\c6Your controllee respawned!");
			
			%this.controller.isControlling = 0;
			%this.isControlled = 0;
			
			%this.controller.controlling = "";
			%this.controller = "";
		}
		
		Parent::CreatePlayer(%this, %spawnPoint);
	}
	
	function serverCmdUseTool(%client, %slot)
	{
		if(%client.player.isFrozen || %client.player.isJailed)
			return;
		
		Parent::serverCmdUseTool(%client, %slot);
	}
	
	function getTrustLevel(%player, %object)
	{
    	if(%player.isJailed)
			return 0;
			
    	return parent::getTrustLevel(%player, %object);
	}

	
	function serverCmdCreateMinigame(%client, %name, %color, %bool)
	{
		if(%client.player.isJailed || %client.player.isFrozen || %client.isControlled)
			return;
		
		Parent::serverCmdCreateMinigame(%client, %name, %color, %bool);
	}
	
	function serverCmdJoinMinigame(%client, %minigame, %a, %b, %c)
	{
		if(%client.player.isJailed || %client.player.isFrozen || %client.isControlled)
			return;
		
		Parent::serverCmdJoinMinigame(%client, %minigame, %a, %b, %c);
	}
	
	function serverCmdUseInventory(%client, %slot)
	{
		if(%client.player.isJailed || %client.player.isFrozen || %client.isControlled)
			return;
		
		Parent::serverCmdUseInventory(%client, %slot);
	}
	
	function Player::Damage(%this, %damager, %pos, %damageInflicted, %damage, %damageType)
	{
		if(%this.isJailed || %this.isFrozen)
			return;
		
		Parent::Damage(%this, %damager, %pos, %damageInflicted, %damage, %damageType);
	}

	function GameConnection::applyBodyColors(%this)
	{
		if(isObject(%player = %this.player))
			if(%player.isFrozen || %player.isJailed)
				return;
				
		Parent::applyBodyColors(%this);
	}

	function GameConnection::applyBodyParts(%this)
	{
		if(isObject(%player = %this.player))
			if(%player.isFrozen || %player.isJailed)
				return;

		Parent::applyBodyParts(%this);
	}
};
activatePackage(ExtraCommandsOverridesPackage);